/*********************************************************************
 *                                                  fxu - LD LRC.mq4 *
 *                                                                   *
 *                                                                   *
 *********************************************************************/
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1  PowderBlue
#property indicator_style1  STYLE_DOT
#property indicator_width1  1
#property indicator_color2  PowderBlue
#property indicator_style2  STYLE_DOT
#property indicator_width2  1
#property indicator_color3  PowderBlue
#property indicator_style3  STYLE_DOT
#property indicator_width3  1
#property indicator_color4  PowderBlue
#property indicator_style4  STYLE_DOT
#property indicator_width4  1
#property indicator_color5  PowderBlue
#property indicator_style5  STYLE_DOT
#property indicator_width5  1
#property indicator_color6  PowderBlue
#property indicator_style6  STYLE_SOLID
#property indicator_width6  1
#property indicator_color7  PowderBlue
#property indicator_style7  STYLE_SOLID
#property indicator_width7  1
#property indicator_color8  PowderBlue
#property indicator_style8  STYLE_SOLID
#property indicator_width8  1

extern int lrcLength    = 0;
extern int lrcShift     = 0;
extern int zigzagShift  = 1;
extern int extDepth     = 100;
extern int extDeviation = 1;
extern int extBackstep  = 3;

int lrcStart = 0;

double lrcValue[];
double lrcUpper[];
double lrcLower[];
double lrcUpExt[];
double lrcLoExt[];
double lrcm[];
double lrcu[];
double lrcl[];

/*********************************************************************
 * init                                                              *
 *********************************************************************/
int init()
{
   int i;
   
   IndicatorBuffers(8);
   
   SetIndexBuffer(i, lrcValue);
   SetIndexStyle(i, DRAW_LINE);
   SetIndexLabel(i, "Linear Regression");
   SetIndexEmptyValue(i, 0.0);
   i++;
   
   SetIndexBuffer(i, lrcUpper);
   SetIndexStyle(i, DRAW_LINE);
   SetIndexLabel(i, "Linear Regression");
   SetIndexEmptyValue(i, 0.0);
   i++;
   
   SetIndexBuffer(i, lrcLower);
   SetIndexStyle(i, DRAW_LINE);
   SetIndexLabel(i, "Linear Regression");
   SetIndexEmptyValue(i, 0.0);
   i++;
   
   SetIndexBuffer(i, lrcUpExt);
   SetIndexStyle(i, DRAW_LINE);
   SetIndexLabel(i, "Linear Regression");
   SetIndexEmptyValue(i, 0.0);
   i++;
   
   SetIndexBuffer(i, lrcLoExt);
   SetIndexStyle(i, DRAW_LINE);
   SetIndexLabel(i, "Linear Regression");
   SetIndexEmptyValue(i, 0.0);
   i++;
   
   SetIndexBuffer(i, lrcm);
   SetIndexStyle(i, DRAW_LINE);
   SetIndexEmptyValue(i, 0.0);
   i++;
   
   SetIndexBuffer(i, lrcu);
   SetIndexStyle(i, DRAW_LINE);
   SetIndexEmptyValue(i, 0.0);
   i++;
   
   SetIndexBuffer(i, lrcl);
   SetIndexStyle(i, DRAW_LINE);
   SetIndexEmptyValue(i, 0.0);
   i++;
   
   IndicatorShortName("fxu - LD LRC");
   
   IndicatorDigits(Digits);
   
   return(0);
}

/*********************************************************************
 * deinit                                                            *
 *********************************************************************/
int deinit()
{
   return(0);
}

/*********************************************************************
 * start                                                             *
 *********************************************************************/
int start()
{
   setData();
   
   // variables
   double a,b,c,m,
          sumy=0.0,
          sumx=0.0,
          sumxy=0.0,
          sumx2=0.0,
          h=0.0,l=0.0;   
   int i,x,length;
   
   length = lrcStart-lrcShift;
   
   // calculate linear regression
   
   for(i=lrcShift;i<lrcStart;i++)
   {
      sumy  += Close[i];
      sumxy += Close[i]*i;
      sumx  += i;
      sumx2 += i*i;
   }
   
   c = sumx2*length-sumx*sumx;
   
   if(c==0.0)
   {
      return;
   }
   
   // Line equation    
   b = (sumxy*length-sumx*sumy)/c;
   a = (sumy-sumx*b)/length;
   
   // Linear regression line in buffer
   for(x=lrcShift;x<lrcStart;x++)
   {
      lrcm[x] = a+b*x;
   }
   
   for(x=lrcShift;x<lrcStart;x++)
   {
      m = Close[x];
      if(m-lrcm[x] > h)
      {
         h = m-lrcm[x];
      }
      if(lrcValue[x]-m > l)
      {
         l = lrcm[x]-m;
      }
   }
   
   // Drawing support - resistance lines   
   if(h>l)
   {
      for(x=lrcShift;x<lrcStart;x++)
      {
         lrcl[x] = a-h+b*x;
         lrcu[x] = a+h+b*x;
      }
   }
   else
   {
      for(x=lrcShift;x<lrcStart;x++)
      {
         lrcl[x] = a-l+b*x;
         lrcu[x] = a+l+b*x;
      }
   }
   
   lrcm[x] = 0.0;
   lrcu[x] = 0.0;
   lrcl[x] = 0.0;
   
   for(i=lrcStart;i>=0;i--)
   {
      if(lrcm[i] != 0.0)
      {
         lrcValue[i] = lrcm[i];
         lrcUpper[i] = lrcu[i];
         lrcLower[i] = lrcl[i];
      }
      else
      {
         lrcValue[i] = lrcValue[i+1]-(lrcValue[i+2]-lrcValue[i+1]);
         lrcUpper[i] = lrcUpper[i+1]-(lrcUpper[i+2]-lrcUpper[i+1]);
         lrcLower[i] = lrcLower[i+1]-(lrcLower[i+2]-lrcLower[i+1]);
      }
   }
   
   SetIndexDrawBegin(0,Bars-lrcStart);
   SetIndexDrawBegin(1,Bars-lrcStart);
   SetIndexDrawBegin(2,Bars-lrcStart);
   SetIndexDrawBegin(3,Bars-lrcStart);
   SetIndexDrawBegin(4,Bars-lrcStart);
   SetIndexDrawBegin(5,Bars-lrcStart);
   SetIndexDrawBegin(6,Bars-lrcStart);
   SetIndexDrawBegin(7,Bars-lrcStart);
   
   return(0);
}

/*********************************************************************
 * setData                                                           *
 *********************************************************************/
void setData()
{
   if(lrcLength == 0)
   {
      int    i;
      int    zCount   = 0;
      int    oneShift = 0;
      int    twoShift = 0;
      bool   oneFound = false;
      bool   twoFound = false;
      double zigZag   = 0;
      
      for(i=0;i<=Bars;i++)
      {
         zigZag = iCustom(NULL,0,"ZigZag",extDepth,extDeviation,extBackstep,0,i);
         
         if(zigZag > 0.0)
         {
            zCount++;
         }
         if(zigZag > 0.0 && zCount >= zigzagShift)
         {
            if(oneFound == false)
            {
               oneFound = true;
               oneShift = i;
            }
            if(oneFound == true && twoFound == false && i > oneShift)
            {
               twoFound = true;
               twoShift = i;
               break;
            }
         }
      }
      
      lrcShift = oneShift;
      lrcStart = twoShift+1;
   }
   else
   {
      lrcStart = lrcShift+lrcLength;
   }
}

/*********************************************************************/